const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const inventory_items = sequelize.define(
    'inventory_items',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

batch_code: {
        type: DataTypes.TEXT,
      
      

      },

expiry_date: {
        type: DataTypes.DATE,
      
      

      },

quantity_on_hand: {
        type: DataTypes.INTEGER,
      
      

      },

reorder_level: {
        type: DataTypes.INTEGER,
      
      

      },

unit_cost: {
        type: DataTypes.DECIMAL,
      
      

      },

stock_status: {
        type: DataTypes.ENUM,
      
      

        values: [

"in_stock",


"low_stock",


"out_of_stock",


"expired",


"quarantined"

        ],

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  inventory_items.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity


























//end loop



    db.inventory_items.belongsTo(db.organizations, {
      as: 'organization',
      foreignKey: {
        name: 'organizationId',
      },
      constraints: false,
    });

    db.inventory_items.belongsTo(db.medicines, {
      as: 'medicine',
      foreignKey: {
        name: 'medicineId',
      },
      constraints: false,
    });




    db.inventory_items.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.inventory_items.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return inventory_items;
};


